<template>
  <div class="hello">
    <h2 v-if="store.winner !== '' " style="textAlign:center;">Winner of the Game :{{store.winner}}</h2>
    <div class="col-3 main-board" >
        <div class="col-12 row first-row">
            <div class='col-4 first-column' @click="play(0)">
                <span class="span-text" >{{store.space[0]}}</span>
            </div>

            <div class="col-4 second-column" @click="play(1)">
                <span class="span-text">{{store.space[1]}}</span>
            </div>

            <div class="col-4 third-column" @click="play(2)">
                <span class="span-text">{{store.space[2]}}</span>
            </div>
        </div>

        <div class="col-12 row second-row">
            <div class='col-4 first-column' @click="play(3)">
                <span class="span-text">{{store.space[3]}}</span>
            </div>

            <div class="col-4 second-column" @click="play(4)">
                <span class="span-text">{{store.space[4]}}</span>
            </div>

            <div class="col-4 third-column" @click="play(5)">
                <span class="span-text">{{store.space[5]}}</span>
            </div>
        </div>

        <div class="col-12 row third-row">
            <div class='col-4 first-column' @click="play(6)">
                <span class="span-text">{{store.space[6]}}</span>
            </div>

            <div class="col-4 second-column" @click="play(7)">
                <span class="span-text">{{store.space[7]}}</span>
            </div>

            <div class="col-4 third-column" @click="play(8)">
                <span class="span-text">{{store.space[8]}}</span>
            </div>
        </div>

    </div>
  </div>
</template>

<script>
import { store } from '@/store';
export default {
  name: 'GameBoard',
  data() {
    return {
      spacedata:[],
      store
    }
  },
  mounted(){
    console.log("here")
    this.store.setCurrentGameStatus(this.store.space)
  },
  methods:{
    async play(i) {
        if(this.store.currentGameStatus.length >0 && this.store.currentGameStatus[i] || this.store.winner){
            return;
        }else{
            let updatedSpace = [...this.store.space];

            if(this.store.currentGameStatus.length === 0){
                updatedSpace[i] = 'X'
            }else{
                if(this.store.lastPlay === 'X'){
                    updatedSpace[i] = 'O' 
                }else{
                    updatedSpace[i] = 'X'  
                }
            }
            console.log("updatedSpace",updatedSpace)
            this.spacedata = this.store.setSpace(updatedSpace[i],i)
            // setSpace(updatedSpace)
            // setLastPlay(updatedSpace[i])
            this.store.setLastPlay(updatedSpace[i])
        }
    },
    async checkWinner(currentGameStatus){
      let winningArr = [
        [0, 1, 2],
        [3, 4, 5],
        [6, 7, 8],
        [0, 3, 6],
        [1, 4, 7],
        [2, 5, 8],
        [0, 4, 8],
        [2, 4, 6],
      ]
      for(let idx in winningArr){
        let arr = winningArr[idx]
        let [a,b,c] = arr

        if(currentGameStatus[a] && currentGameStatus[a] === currentGameStatus[b] && currentGameStatus[b] === currentGameStatus[c]){
          return currentGameStatus[a]
        }  
      }
      return null
    }
  },
  watch:{
    async spacedata(){
      this.store.setCurrentGameStatus(this.store.space)
      let getwinner = await this.checkWinner(this.store.currentGameStatus)
      console.log("getwinner:::",getwinner)
      if(getwinner !== null ){
        this.store.setWinner(getwinner)
      }
    }
  }

}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style >
 @import '../css/Board.css  '
</style>
